--このように、BASICを起動させないプログラムも書けます。NScripter2の内部関数を使って処理をしています。

function NS2Archive()
	console.print("■NS2アーカイブ作成■")
	console.print("圧縮するフォルダを選択してください。全角文字の含まれたフォルダ名やファイル名は使わないでください。")
	dir=gui.dirdialog()
	if dir==nil then return end
	console.print("保存ファイル名を指定してください。NScripter2は00.ns2～99.ns2に対応しており、同一ファイル名の場合大きい番号のアーカイブにあるものが優先です。また、連番である必要はありません。")
	local fn=gui.savedialog("ns2","00.ns2")
	if fn==nil then return end
	local ufn=encoding.ansi_to_utf8(fn)
	local udir=encoding.ansi_to_utf8(dir)
	console.print("ファイル名\""..ufn.."\"（圧縮対象フォルダ\""..udir.."\"）の処理を開始します。")
	encoding.createarchive(fn,dir,true)
	console.print("ファイル名\""..ufn.."\"（圧縮対象フォルダ\""..udir.."\"）の処理を完了しました。")
	os.execute("pause")
end

function PNGtoAVI()
	console.print("■連番PNGから透過形式AVI作成■")
	console.print("連番PNGを格納したフォルダを選択してください。")
	dir=gui.dirdialog()
	if dir==nil then return end
	console.print("保存ファイル名を指定してください。")
	local fn=gui.savedialog("avi")
	if fn==nil then return end
	console.write ("フレームレートを入力してください。\n> ")
	local fps=tonumber(console.readline())
	if fps==nil then return end
	local ufn=encoding.ansi_to_utf8(fn)
	local udir=encoding.ansi_to_utf8(dir)
	console.print("ファイル名\""..ufn.."\"（対象フォルダ\""..udir.."\"）の処理を開始します。")
	local tbl=gui.getfilelist(dir,"png")
	table.sort(tbl)
	local firstflag=true
	for i,v in ipairs(tbl) do
		console.print (encoding.ansi_to_utf8(v).."を処理しています。")
		if v:sub(-3):lower()=="png" then
			bmp=bitmap.load(dir..v)
			if firstflag then
				local w,h=bmp:getsize()
				movie.writebegin(fn,w*2,h,fps,#v)
				firstflag=false
			end
			bmp:expandalpha()
			movie.write(i-1,bmp)
		end
	end
	movie.writeend()
	console.print("ファイル名\""..ufn.."\"（対象フォルダ\""..udir.."\"）の処理を完了しました。")
	os.execute("pause")
end

function AVIConvert()
	console.print("■α値付き無圧縮AVIから透過形式AVI作成■")
	console.print("α値付き無圧縮AVIファイルを指定してください。")
	local infn=gui.loaddialog("avi")
	if infn==nil then return end

	console.print("保存ファイル名を指定してください。")
	local fn=gui.savedialog("avi")
	if fn==nil then return end

	if infn==fn then console.print ("※入力ファイルと出力ファイルが同じです。") os.execute("pause") return end

	local uinfn=encoding.ansi_to_utf8(infn)
	local ufn=encoding.ansi_to_utf8(fn)
	console.print("コンバート \""..uinfn.."\" -> \""..ufn.."\" の処理を開始します。")

	movie.readbegin(infn)
	local n,fps=movie.readframeinfo()
	local firstflag=true
	for i=0,n-1 do
		local bmp=movie.read(i)
		if firstflag then
			local w,h=bmp:getsize()
			movie.writebegin(fn,w*2,h,fps,n)
			firstflag=false
		end
		bmp:expandalpha()
		console.print (i.."フレーム目を処理しています。")
		movie.write(i,bmp)
	end
	movie.readend()
	movie.writeend()
	console.print("コンバート \""..uinfn.."\" -> \""..ufn.."\" の処理を完了しました。")
	os.execute("pause")
end


console.print("---------------------------------")
console.print("-- NScripter2 開発用ツール")
console.print("---------------------------------")
while true do
	console.print("\n■MENU■")
	console.print("0:終了する")
	console.print("1:ns2アーカイブ作成")
	console.print("2:透過連番PNGをNScripter2の透過形式AVIに変換")
	console.print("3:α値付きの無圧縮AVIをNScripter2の透過形式AVIに変換")
	console.print("")
	console.write("> ")
	num=tonumber(console.readline())
	if num==0 then
		os.exit(0)
	elseif num==1 then
		NS2Archive()
	elseif num==2 then
		PNGtoAVI()
	elseif num==3 then
		AVIConvert()
	end
end
